/////////////////////////////////////////////////////////////////////////////
//
// CPFConstant.cpp
//
// Rémi Coulom
//
// May, 2010
//
/////////////////////////////////////////////////////////////////////////////
#include "CPFConstant.h"

/////////////////////////////////////////////////////////////////////////////
// GetValue
/////////////////////////////////////////////////////////////////////////////
double CPFConstant::GetValue(const double *vParam, const double *vx) const
{
 return vParam[0];
}

/////////////////////////////////////////////////////////////////////////////
// GetMax
/////////////////////////////////////////////////////////////////////////////
bool CPFConstant::GetMax(const double *vParam, double *vx) const
{
 for (int i = Dimensions; --i >= 0;)
  vx[i] = 0.0;
 return true;
}

/////////////////////////////////////////////////////////////////////////////
// GetMonomials
/////////////////////////////////////////////////////////////////////////////
void CPFConstant::GetMonomials(const double *vx, double *vMonomial) const
{
 vMonomial[0] = 1.0;
}

/////////////////////////////////////////////////////////////////////////////
// GetGradient
/////////////////////////////////////////////////////////////////////////////
void CPFConstant::GetGradient(const double *vParam,
                              const double *vx,
                              double *vG) const
{
 for (int i = Dimensions; --i >= 0;)
  vG[i] = 0.0;
}
