/////////////////////////////////////////////////////////////////////////////
//
// CGammaParameter.cpp
//
// Rémi Coulom
//
// March, 2011
//
/////////////////////////////////////////////////////////////////////////////
#include "CGammaParameter.h"
#include <cmath>

/////////////////////////////////////////////////////////////////////////////
// Constructor
/////////////////////////////////////////////////////////////////////////////
CGammaParameter::CGammaParameter(const std::string &s,
                                 double Min,
                                 double Max):
 CParameter(s),
 Min(Min),
 Max(Max)
{}

/////////////////////////////////////////////////////////////////////////////
// Transform x to the [-1, 1] range
/////////////////////////////////////////////////////////////////////////////
double CGammaParameter::TransformToQLR(double x) const
{
 double lx = std::log(x);
 double lMin = std::log(Min);
 double lMax = std::log(Max);

 return -1.0 + 2.0 * (lx - lMin) / (lMax - lMin);
}

/////////////////////////////////////////////////////////////////////////////
// Transform x to the [Min, Max] range
/////////////////////////////////////////////////////////////////////////////
double CGammaParameter::TransformFromQLR(double x) const
{
 double lMin = std::log(Min);
 double lMax = std::log(Max);
 double lx = lMin + 0.5 * (x + 1) * (lMax - lMin);
 return std::exp(lx);
}
