/////////////////////////////////////////////////////////////////////////////
//
// CParameterCollection.cpp
//
// Rémi Coulom
//
// August, 2009
//
/////////////////////////////////////////////////////////////////////////////
#include "CParameterCollection.h"
#include "CParameter.h"

/////////////////////////////////////////////////////////////////////////////
// Add a parameter
/////////////////////////////////////////////////////////////////////////////
void CParameterCollection::Add(const CParameter &param)
{
 vpparam.push_back(&param);
 vTranslation.push_back(0.0);
}

/////////////////////////////////////////////////////////////////////////////
// Translate a vector
/////////////////////////////////////////////////////////////////////////////
const double *CParameterCollection::Translate(const double *v) const
{
 for (int i = GetSize(); --i >= 0;)
 {
  const CParameter &param = GetParam(i);
  vTranslation[i] = param.TransformToQLR(param.TransformFromQLR(v[i]));
 }
 return &vTranslation[0];
}
